3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
22 # do not redirect again
24 *' --tee '*|*' --va'*)
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
34 # Keep the original TERM for say_color
37 # For repeatability, reset the environment to known value.
43 export LANG LC_ALL PAGER TERM TZ
50 my $ok = join("|", qw(
58 PERF_AGGREGATING_LATER
60 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
61 print join("\n", @vars);
63 GIT_AUTHOR_EMAIL=author@example.com
64 GIT_AUTHOR_NAME='A U Thor'
65 GIT_COMMITTER_EMAIL=committer@example.com
66 GIT_COMMITTER_NAME='C O Mitter'
69 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
70 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
71 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
74 # Protect ourselves from common misconfiguration to export
75 # CDPATH into the environment
80 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
82 echo "* warning: Some tests will not work if GIT_TRACE" \
83 "is set as to trace on STDERR ! *"
84 echo "* warning: Please set GIT_TRACE to something" \
85 "other than 1, 2 or true ! *"
91 # A regexp to match 5 and 40 hexdigits
92 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
93 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
96 _z40=0000000000000000000000000000000000000000
102 export _x05 _x40 _z40 LF
104 # Each test should start with something like this, after copyright notices:
106 # test_description='Description of this test...
107 # This test checks if command xyzzy does the right thing...
110 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
111 TERM=$ORIGINAL_TERM &&
114 tput bold >/dev/null 2>&1 &&
115 tput setaf 1 >/dev/null 2>&1 &&
116 tput sgr0 >/dev/null 2>&1
120 while test "$#" -ne 0
123 -d|--d|--de|--deb|--debu|--debug)
125 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
126 immediate=t; shift ;;
127 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
128 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
129 -h|--h|--he|--hel|--help)
131 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
133 -q|--q|--qu|--qui|--quie|--quiet)
134 # Ignore --quiet under a TAP::Harness. Saying how many tests
135 # passed without the ok/not ok details is always an error.
136 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
138 with_dashes=t; shift ;;
141 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
142 valgrind=t; verbose=t; shift ;;
144 shift ;; # was handled already
146 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
149 echo "error: unknown test option '$1'" >&2; exit 1 ;;
153 if test -n "$color"; then
159 error) tput bold; tput setaf 1;; # bold red
160 skip) tput bold; tput setaf 2;; # bold green
161 pass) tput setaf 2;; # green
162 info) tput setaf 3;; # brown
163 *) test -n "$quiet" && return;;
173 test -z "$1" && test -n "$quiet" && return
180 say_color error "error: $*"
189 test "${test_description}" != "" ||
190 error "Test script did not set test_description."
192 if test "$help" = "t"
194 echo "$test_description"
200 if test "$verbose" = "t"
204 exec 4>/dev/null 3>/dev/null
213 test_external_has_tap=0
217 if test -n "$GIT_EXIT_OK"
221 echo >&5 "FATAL: Unexpected exit with code $code"
229 # The user-facing functions are loaded from a separate file so that
230 # test_perf subshells can have them too
231 . "${TEST_DIRECTORY:-.}"/test-lib-functions.sh
233 # You are not expected to call test_ok_ and test_failure_ directly, use
234 # the text_expect_* functions instead.
237 test_success=$(($test_success + 1))
238 say_color "" "ok $test_count - $@"
242 test_failure=$(($test_failure + 1))
243 say_color error "not ok - $test_count $1"
245 echo "$@" | sed -e 's/^/# /'
246 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
249 test_known_broken_ok_ () {
250 test_fixed=$(($test_fixed+1))
251 say_color "" "ok $test_count - $@ # TODO known breakage"
254 test_known_broken_failure_ () {
255 test_broken=$(($test_broken+1))
256 say_color skip "not ok $test_count - $@ # TODO known breakage"
260 test "$debug" = "" || eval "$1"
264 # This is a separate function because some tests use
265 # "return" to end a test_expect_success block early.
266 eval </dev/null >&3 2>&4 "$*"
275 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
277 test_eval_ "$test_cleanup"
279 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
286 test_count=$(($test_count+1))
288 for skp in $GIT_SKIP_TESTS
290 case $this_test.$test_count in
296 if test -z "$to_skip" && test -n "$test_prereq" &&
297 ! test_have_prereq "$test_prereq"
304 if test "$missing_prereq" != "$test_prereq"
306 of_prereq=" of $test_prereq"
309 say_color skip >&3 "skipping test: $@"
310 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
319 # stub; perf-lib overrides it
320 test_at_end_hook_ () {
327 if test -z "$HARNESS_ACTIVE"; then
328 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
329 mkdir -p "$test_results_dir"
330 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
332 cat >>"$test_results_path" <<-EOF
334 success $test_success
342 if test "$test_fixed" != 0
344 say_color pass "# fixed $test_fixed known breakage(s)"
346 if test "$test_broken" != 0
348 say_color error "# still have $test_broken known breakage(s)"
349 msg="remaining $(($test_count-$test_broken)) test(s)"
351 msg="$test_count test(s)"
353 case "$test_failure" in
355 # Maybe print SKIP message
356 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
358 if test $test_external_has_tap -eq 0; then
359 say_color pass "# passed all $msg"
360 say "1..$test_count$skip_all"
363 test -d "$remove_trash" &&
364 cd "$(dirname "$remove_trash")" &&
365 rm -rf "$(basename "$remove_trash")"
372 if test $test_external_has_tap -eq 0; then
373 say_color error "# failed $test_failure among $msg"
382 # Test the binaries we have just built. The tests are kept in
383 # t/ subdirectory and are run in 'trash directory' subdirectory.
384 if test -z "$TEST_DIRECTORY"
386 # We allow tests to override this, in case they want to run tests
387 # outside of t/, e.g. for running tests on the test library
389 TEST_DIRECTORY=$(pwd)
391 if test -z "$TEST_OUTPUT_DIRECTORY"
393 # Similarly, override this to store the test-results subdir
395 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
397 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
399 if test -n "$valgrind"
403 test "$1" = "$(readlink "$2")" || {
411 while test -d "$2".lock
413 say "Waiting for lock on $2."
420 make_valgrind_symlink () {
421 # handle only executables, unless they are shell libraries that
422 # need to be in the exec-path. We will just use "#!" as a
423 # guess for a shell-script, since we have no idea what the user
424 # may have configured as the shell path.
426 test "#!" = "$(head -c 2 <"$1")" ||
429 base=$(basename "$1")
430 symlink_target=$GIT_BUILD_DIR/$base
431 # do not override scripts
432 if test -x "$symlink_target" &&
433 test ! -d "$symlink_target" &&
434 test "#!" != "$(head -c 2 < "$symlink_target")"
436 symlink_target=../valgrind.sh
440 symlink_target=../unprocessed-script
442 # create the link, or replace it if it is out of date
443 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
446 # override all git executables in TEST_DIRECTORY/..
447 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
448 mkdir -p "$GIT_VALGRIND"/bin
449 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
451 make_valgrind_symlink $file
453 # special-case the mergetools loadables
454 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
459 ls "$path"/git-* 2> /dev/null |
462 make_valgrind_symlink "$file"
466 PATH=$GIT_VALGRIND/bin:$PATH
467 GIT_EXEC_PATH=$GIT_VALGRIND/bin
469 elif test -n "$GIT_TEST_INSTALLED" ; then
470 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
471 error "Cannot run git from $GIT_TEST_INSTALLED."
472 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
473 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
474 else # normal case, use ../bin-wrappers only unless $with_dashes:
475 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
476 if ! test -x "$git_bin_dir/git" ; then
477 if test -z "$with_dashes" ; then
478 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
482 PATH="$git_bin_dir:$PATH"
483 GIT_EXEC_PATH=$GIT_BUILD_DIR
484 if test -n "$with_dashes" ; then
485 PATH="$GIT_BUILD_DIR:$PATH"
488 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
490 GIT_CONFIG_NOSYSTEM=1
492 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
494 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
496 if test -z "$GIT_TEST_CMP"
498 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
500 GIT_TEST_CMP="$DIFF -c"
502 GIT_TEST_CMP="$DIFF -u"
506 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
508 test -d "$GIT_BUILD_DIR"/templates/blt || {
509 error "You haven't built things yet, have you?"
512 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
514 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
516 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
517 error "You haven't built git_remote_helpers yet, have you?"
521 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
522 echo >&2 'You need to build test-chmtime:'
523 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
528 test="trash directory.$(basename "$0" .sh)"
529 test -n "$root" && test="$root/$test"
531 /*) TRASH_DIRECTORY="$test" ;;
532 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
534 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
537 echo >&5 "FATAL: Cannot prepare test area"
541 HOME="$TRASH_DIRECTORY"
544 if test -z "$TEST_NO_CREATE_REPO"; then
545 test_create_repo "$test"
549 # Use -P to resolve symlinks in our working directory so that the cwd
550 # in subprocesses like git equals our $PWD (for pathname comparisons).
551 cd -P "$test" || exit 1
554 this_test=${this_test%%-*}
555 for skp in $GIT_SKIP_TESTS
559 say_color skip >&3 "skipping test $this_test altogether"
560 skip_all="skip all tests in $this_test"
565 # Provide an implementation of the 'yes' utility
580 # Fix some commands on Windows
583 # Windows has its own (incompatible) sort and find
593 # git sees Windows-style pwd
597 # no POSIX permissions
598 # backslashes in pathspec are converted to '/'
599 # exec does not inherit the PID
600 test_set_prereq MINGW
601 test_set_prereq SED_STRIPS_CR
604 test_set_prereq POSIXPERM
605 test_set_prereq EXECKEEPSPID
606 test_set_prereq NOT_MINGW
607 test_set_prereq SED_STRIPS_CR
610 test_set_prereq POSIXPERM
611 test_set_prereq BSLASHPSPEC
612 test_set_prereq EXECKEEPSPID
613 test_set_prereq NOT_MINGW
617 test -z "$NO_PERL" && test_set_prereq PERL
618 test -z "$NO_PYTHON" && test_set_prereq PYTHON
619 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
620 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
622 # Can we rely on git's output in the C locale?
623 if test -n "$GETTEXT_POISON"
625 GIT_GETTEXT_POISON=YesPlease
626 export GIT_GETTEXT_POISON
627 test_set_prereq GETTEXT_POISON
629 test_set_prereq C_LOCALE_OUTPUT
632 # Use this instead of test_cmp to compare files that contain expected and
633 # actual output from git commands that can be translated. When running
634 # under GETTEXT_POISON this pretends that the command produced expected
637 test -n "$GETTEXT_POISON" || test_cmp "$@"
640 # Use this instead of "grep expected-string actual" to see if the
641 # output from a git command that can be translated either contains an
642 # expected string, or does not contain an unwanted one. When running
643 # under GETTEXT_POISON this pretends that the command produced expected
646 if test -n "$GETTEXT_POISON"
649 elif test "x!" = "x$1"
658 # test whether the filesystem supports symbolic links
659 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
662 # When the tests are run as root, permission tests will report that
663 # things are writable when they shouldn't be.
664 test -w / || test_set_prereq SANITY